vsg: vsg::RecordAndSubmitTask Class Reference

vsg 1.1.3 VulkanSceneGraph library

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Protected Attributes | List of all members
vsg::RecordAndSubmitTask Class Reference

RecordAndSubmitTask manages the recording of its list of CommandGraph to CommandBuffer which are then submitted to the associated vulkan Queue. More...

`#include <RecordAndSubmitTask.h>`

Inheritance diagram for vsg::RecordAndSubmitTask:
[legend]
Collaboration diagram for vsg::RecordAndSubmitTask:
[legend]

## Public Member Functions
| RecordAndSubmitTask (Device *in_device, uint32_t numBuffers=3)
virtual VkResult | submit (ref_ptr< FrameStamp > frameStamp={})
virtual VkResult | start ()
virtual VkResult | record (ref_ptr< RecordedCommandBuffers > recordedCommandBuffers, ref_ptr< FrameStamp > frameStamp)
virtual VkResult | finish (ref_ptr< RecordedCommandBuffers > recordedCommandBuffers)
void | advance ()
| advance the currentFrameIndex
size_t | index (size_t relativeFrameIndex=0) const
| return the fence index value for relativeFrameIndex where 0 is current frame, 1 is previous frame etc.
Fence * | fence (size_t relativeFrameIndex=0)
| fence() and fence(0) return the Fence for the frame currently being rendered, fence(1) returns the previous frame's Fence etc.
void | assignInstrumentation (ref_ptr< Instrumentation > in_instrumentation)
| Convenience method for assigning Instrumentation to the viewer and any associated objects.
Public Member Functions inherited from vsg::Inherit< Object, RecordAndSubmitTask >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T >
T * | cast ()
template<class T >
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | traverse (ConstVisitor &) const
virtual void | traverse (RecordTraversal &) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T >
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T >
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T >
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T >
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T >
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T >
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Public Attributes
ref_ptr< Device > | device
Windows | windows
Semaphores | waitSemaphores
CommandGraphs | commandGraphs
Semaphores | signalSemaphores
ref_ptr< TransferTask > | earlyTransferTask
ref_ptr< Semaphore > | earlyTransferTaskConsumerCompletedSemaphore
ref_ptr< TransferTask > | lateTransferTask
ref_ptr< Semaphore > | lateTransferTaskConsumerCompletedSemaphore
ref_ptr< Queue > | queue
ref_ptr< DatabasePager > | databasePager
ref_ptr< Instrumentation > | instrumentation
| hook for assigning Instrumentation to enable profiling of record traversal.

## Protected Attributes
size_t | _currentFrameIndex
std::vector< size_t > | _indices
std::vector< ref_ptr< Fence > > | _fences

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Object, RecordAndSubmitTask >
static ref_ptr< RecordAndSubmitTask > | create (Args &&... args)
static ref_ptr< RecordAndSubmitTask > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

RecordAndSubmitTask manages the recording of its list of CommandGraph to CommandBuffer which are then submitted to the associated vulkan Queue.

The documentation for this class was generated from the following file:

- include/vsg/app/RecordAndSubmitTask.h